# 1. Importing the required TECH file.
import si_fab.all as pdk  # noqa
from picazzo3.traces.wire_wg import WireWaveguideTemplate
from ring import RingResonator

# 3.  Create a new RingResonator object
#     Provide a unique name
my_ring = RingResonator(name="myring")
# 4. Instantiate the default layout view.
my_ring_layout = my_ring.Layout()
my_ring_layout.write_gdsii("myring.gds")
my_ring_layout.visualize()

# 5. Inspect the (default) waveguide template currently used for the ring
my_ring_layout.wg_template.cross_section().visualize()

# 6. Create a new waveguide template with a non-standard width

new_wg_template = WireWaveguideTemplate(name="my_wire_t")
new_wg_template_layout = new_wg_template.Layout(core_width=0.1)
new_wg_template_layout.cross_section().visualize()

# 7.  Use the new template in a new ring
my_ring_2 = RingResonator(name="myring2", wg_template=new_wg_template)
# 8. Instantiate the layout.
my_ring_2_layout = my_ring_2.Layout()
my_ring_2_layout.write_gdsii("myring2.gds")
my_ring_2_layout.visualize()
